loci.plugins.util

## Class DataBrowser

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Frame
        - - ij.gui.ImageWindow
          - - ij.gui.StackWindow
            - - loci.plugins.util.DataBrowser

- All Implemented Interfaces:
    java.awt.event.ActionListener, java.awt.event.AdjustmentListener, java.awt.event.FocusListener, java.awt.event.MouseWheelListener, java.awt.event.WindowListener, java.awt.event.WindowStateListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.lang.Runnable, java.util.EventListener, javax.accessibility.Accessible

      public class DataBrowser
      extends ij.gui.StackWindow

  Extension of StackWindow with additional UI trimmings for animation, virtual stack caching options, metadata, and general beautification.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.awt.Frame

      `java.awt.Frame.AccessibleAWTFrame`

    - ### Nested classes/interfaces inherited from class java.awt.Window

      `java.awt.Window.AccessibleAWTWindow, java.awt.Window.Type`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `allowShow`
    `protected boolean` | `anim`
    `protected java.awt.Button` | `animate`
    `protected int[]` | `cIndex`
    `protected int[]` | `cLengths`
    `protected java.awt.Scrollbar` | `cScroll`
    `protected java.awt.Scrollbar[]` | `cSliders`
    `protected javax.swing.JSpinner` | `fpsSpin`
    `protected java.awt.Button` | `metadata`
    `protected XMLWindow` | `metaWindow`
    `protected static int` | `MIN_BROWSER_WIDTH`
    `protected java.awt.Button` | `options`
    `protected BrowserOptionsWindow` | `optionsWindow`
    `protected java.awt.Scrollbar` | `tScroll`
    `protected java.lang.String` | `xml`
    `protected java.awt.Scrollbar` | `zScroll`

    - ### Fields inherited from class ij.gui.StackWindow

      `animationSelector, cSelector, done, slice, sliceSelector, thread, tSelector, zSelector`

    - ### Fields inherited from class ij.gui.ImageWindow

      `closed, HGAP, ic, ij, imp, LOC_KEY, MIN_HEIGHT, MIN_WIDTH, running, running2, setMenuBarTime, VGAP`

    - ### Fields inherited from class java.awt.Frame

      `CROSSHAIR_CURSOR, DEFAULT_CURSOR, E_RESIZE_CURSOR, HAND_CURSOR, ICONIFIED, MAXIMIZED_BOTH, MAXIMIZED_HORIZ, MAXIMIZED_VERT, MOVE_CURSOR, N_RESIZE_CURSOR, NE_RESIZE_CURSOR, NORMAL, NW_RESIZE_CURSOR, S_RESIZE_CURSOR, SE_RESIZE_CURSOR, SW_RESIZE_CURSOR, TEXT_CURSOR, W_RESIZE_CURSOR, WAIT_CURSOR`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DataBrowser(ij.ImagePlus imp)`
    `DataBrowser(ij.ImagePlus imp, ij.gui.ImageCanvas ic, java.lang.String[] channels, int[] cLengths)`
    `DataBrowser(ij.ImagePlus imp, ij.gui.ImageCanvas ic, java.lang.String[] channels, int[] cLengths, XMLWindow xmlWindow)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `actionPerformed(java.awt.event.ActionEvent e)`
    `void` | `adjustmentValueChanged(java.awt.event.AdjustmentEvent e)`
    `protected static java.awt.Scrollbar` | `makeDummySlider()`
    `protected static java.awt.Panel` | `makeHeavyPanel(java.awt.Component c)` Makes AWT play nicely with Swing components.
    `void` | `mouseWheelMoved(java.awt.event.MouseWheelEvent event)`
    `void` | `pack()` Overridden pack method to allow us to delay initial window sizing.
    `void` | `setVisible(boolean b)` Overridden show method to allow us to delay initial window display.
    `void` | `setXML(java.lang.String xml)` Sets XML block associated with this window.
    `void` | `showMetadataWindow()` Displays the OME-XML metadata window onscreen.
    `void` | `showOptionsWindow()` Displays the caching options window onscreen.
    `private void` | `syncPlane()` Updates the ImagePlus's displayed plane to match the slider values.
    `private void` | `syncSliders()` Updates the slider values to match the ImagePlus's displayed plane.
    `void` | `toggleAnimation()` Toggles whether the data browser is animating.

    - ### Methods inherited from class ij.gui.StackWindow

      `close, createSubtitle, getAnimate, getNScrollbars, isHyperStack, run, setAnimate, setPosition, setSlidersEnabled, showSlice, updateSliceSelector, validDimensions`

    - ### Methods inherited from class ij.gui.ImageWindow

      `add, centerNextImage, copy, drawInfo, focusGained, focusLost, getCanvas, getImagePlus, getImageSize, getInitialMagnification, getInsets, getMaximumBounds, getSliderHeight, isClosed, maximize, minimize, mouseMoved, paint, paste, setImage, setImageJMenuBar, setLocation, setLocationAndSize, setNextLocation, setNextLocation, setSliderHeight, toString, updateImage, windowActivated, windowClosed, windowClosing, windowDeactivated, windowDeiconified, windowIconified, windowOpened, windowStateChanged`

    - ### Methods inherited from class java.awt.Frame

      `addNotify, getAccessibleContext, getCursorType, getExtendedState, getFrames, getIconImage, getMaximizedBounds, getMenuBar, getState, getTitle, isResizable, isUndecorated, paramString, remove, removeNotify, setBackground, setCursor, setExtendedState, setIconImage, setMaximizedBounds, setMenuBar, setOpacity, setResizable, setShape, setState, setTitle, setUndecorated`

    - ### Methods inherited from class java.awt.Window

      `addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, hide, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, postEvent, processEvent, processWindowEvent, processWindowFocusEvent, processWindowStateEvent, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImages, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, show, toBack, toFront`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, addContainerListener, addImpl, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, setLayout, transferFocusDownCycle, update, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setName, setPreferredSize, show, size, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.awt.MenuContainer

      `getFont, postEvent`

- - ### Field Detail

    - #### MIN_BROWSER_WIDTH

          protected static final int MIN_BROWSER_WIDTH

      See Also:
        Constant Field Values

    - #### fpsSpin

          protected javax.swing.JSpinner fpsSpin

    - #### animate

          protected java.awt.Button animate

    - #### options

          protected java.awt.Button options

    - #### metadata

          protected java.awt.Button metadata

    - #### anim

          protected boolean anim

    - #### allowShow

          protected boolean allowShow

    - #### metaWindow

          protected XMLWindow metaWindow

    - #### optionsWindow

          protected BrowserOptionsWindow optionsWindow

    - #### xml

          protected java.lang.String xml

    - #### zScroll

          protected java.awt.Scrollbar zScroll

    - #### cScroll

          protected java.awt.Scrollbar cScroll

    - #### tScroll

          protected java.awt.Scrollbar tScroll

    - #### cSliders

          protected java.awt.Scrollbar[] cSliders

    - #### cLengths

          protected int[] cLengths

    - #### cIndex

          protected int[] cIndex

  - ### Constructor Detail

    - #### DataBrowser

          public DataBrowser(ij.ImagePlus imp)

    - #### DataBrowser

          public DataBrowser(ij.ImagePlus imp,
                             ij.gui.ImageCanvas ic,
                             java.lang.String[] channels,
                             int[] cLengths)

    - #### DataBrowser

          public DataBrowser(ij.ImagePlus imp,
                             ij.gui.ImageCanvas ic,
                             java.lang.String[] channels,
                             int[] cLengths,
                             XMLWindow xmlWindow)

  - ### Method Detail

    - #### setXML

          public void setXML(java.lang.String xml)

      Sets XML block associated with this window. This information will be displayed in a tree structure when the Metadata button is clicked.

    - #### toggleAnimation

          public void toggleAnimation()

      Toggles whether the data browser is animating.

    - #### showOptionsWindow

          public void showOptionsWindow()

      Displays the caching options window onscreen.

    - #### showMetadataWindow

          public void showMetadataWindow()

      Displays the OME-XML metadata window onscreen.

    - #### pack

          public void pack()

      Overridden pack method to allow us to delay initial window sizing.
      Overrides:
        `pack` in class `java.awt.Window`

    - #### setVisible

          public void setVisible(boolean b)

      Overridden show method to allow us to delay initial window display.
      Overrides:
        `setVisible` in class `java.awt.Window`

    - #### actionPerformed

          public void actionPerformed(java.awt.event.ActionEvent e)

      Specified by:
        `actionPerformed` in interface `java.awt.event.ActionListener`
      Overrides:
        `actionPerformed` in class `ij.gui.StackWindow`

    - #### adjustmentValueChanged

          public void adjustmentValueChanged(java.awt.event.AdjustmentEvent e)

      Specified by:
        `adjustmentValueChanged` in interface `java.awt.event.AdjustmentListener`
      Overrides:
        `adjustmentValueChanged` in class `ij.gui.StackWindow`

    - #### mouseWheelMoved

          public void mouseWheelMoved(java.awt.event.MouseWheelEvent event)

      Specified by:
        `mouseWheelMoved` in interface `java.awt.event.MouseWheelListener`
      Overrides:
        `mouseWheelMoved` in class `ij.gui.StackWindow`

    - #### syncPlane

          private void syncPlane()

      Updates the ImagePlus's displayed plane to match the slider values.

    - #### syncSliders

          private void syncSliders()

      Updates the slider values to match the ImagePlus's displayed plane.

    - #### makeDummySlider

          protected static java.awt.Scrollbar makeDummySlider()

    - #### makeHeavyPanel

          protected static java.awt.Panel makeHeavyPanel(java.awt.Component c)

      Makes AWT play nicely with Swing components.

Copyright © 2026 Open Microscopy Environment